@extends('dashboard.layouts.default')
@section('content')
<div id="subheader" class="d-flex align-items-center">
  <div class="container-fluid">
    <div class="row align-items-center justify-content-between">
      <div class="col d-flex align-items-center">
        <h5 class="sub-title">Manage Students</h5>
      </div>
      <div class="col-auto"> 
        <div class="tools overflow-auto">
          <button type="button" class="btn btn-info" onClick="javascript:window.open('{{ url('sample/How to set up your school account.pdf')}}', '_blank');"><i class="bx bxs-info-circle me-1"></i>How to set up school account</button>
          <button type="button" class="btn btn-reset" onclick="changePassword(null)"><i class="bx bxs-key me-1"></i>Reset Password</button>
          <button type="button"   class="btn btn-class  @if($wonde_id ) custom-disabled-button @endif"  @if($wonde_id ) disabled @else onclick="moveToClass(null,null)"@endif><i class="bx bxs-chevrons-right me-1"></i>Change Class</button> 
        <!--  <button type="button" class="btn btn-edit" onclick="editStudent(null)"><i class="bx bxs-edit-alt me-1"></i>Edit Student</button> -->
          <button type="button"   class="btn btn-import @if($wonde_id) custom-disabled-button @endif " @if($wonde_id ) disabled @else onclick="importStudent(null)"@endif><i class="bx bx-import me-1"></i>Import Students</button>
          <button type="button" class="btn btn-export d-none" onclick="exportStudent()"><i class="bx bx-export me-1"></i>Export Students</button>
          <button type="button" class="btn btn-add @if($wonde_id) custom-disabled-button @endif "  @if($wonde_id ) disabled @else onclick="addStudent(null)"@endif><i class="bx bxs-plus-circle me-1"></i>Add New Student</button>
          <button type="button" class="btn btn-delete @if($wonde_id) custom-disabled-button @endif " @if($wonde_id ) disabled @else onclick="softDelete(null)" @endif><i class="bx bxs-trash me-1"></i>Delete Students</button>
        </div>
      </div>
    </div>
  </div>
</div>
<section class="top-section settings">
  <div class="container-fluid">
    <div class="row g-3">
      @include('layout.top-ads')
      <div class="col-lg-12">
        <div class="manage-sec">
          <a class="btn btn-manage active" href="{{ url('teacher/student') }}"><i class="bx bxs-group me-1"></i>Manage Students</a>
          <a class="btn btn-manage" href="{{ url('teacher/class') }}"><i class="bx bxs-copy-alt me-1"></i>Manage Classes</a>
          <a class="btn btn-manage" href="{{ url('teacher/teacher') }}"><i class="bx bxs-user-account me-1"></i>Manage Teachers</a>
        </div>
        <div class="card border-rad-left-0">
          <div class="card-body">
            <div class="d-flex align-items-center overflow-auto">
              @foreach($years_filter as $key=>$year)
              <input type="checkbox" class="btn-check checkyear" name="year_id[]" value="{{ $year->id }}" id="year_id-{{ $year->id }}" onclick="setYear(this.value)" autocomplete="off">
              <label class="btn btn-year me-1 mb-1 checkyear" for="year_id-{{ $year->id }}">{{ $year->year }}</label>
              @endforeach
              <input type="hidden" id="year_fil" value=""/>
            </div>
            <div class="d-flex align-items-center overflow-auto mb-2">
              <div class="class-head"></div>
              <input type="hidden" id="class_fil" value=""/>
            </div>
            <table class="table table-striped table-hover " id="dataTables" style="width:100%">
              <thead>
                <tr>
                  <th class="no-export fw-semibold"><input class="form-check-input" type="checkbox" name="selectall" id="selectall"/></th>
                  <th class="no-export fw-semibold" style="display: none;">stud Name</th>
                  <th class="text-start fw-semibold">Name</th>
                  <th class="text-start fw-semibold">Username / Password</th>
                  <th class="text-start fw-semibold">Email</th>
                  <th class="fw-semibold" width="10%">Year</th>
                  <th class="fw-semibold" width="10%">Class</th>
                  <!--   <th>Group</th> -->
                  <!--  <th>Status</th> -->
                  <th class="no-export fw-semibold" width="auto">Action</th>
                </tr>
              </thead>
              <tbody>
              </tbody>
            </table>
            <input type="hidden" name="searched_value" id="searched_value" value=""/>
          </div>
        </div>
        <div class="card">
          <div class="card-body">
          </div>
        </div>
      </div>
      @include('layout.bottom-ads')
    </div>
  </div>
</section>
@include('teacher.students.reset_password_modal')
@include('teacher.students.student_modal')
@include('teacher.students.password')
@include('teacher.students.student_import_modal')
@include('teacher.students.move_class_modal')
@include('teacher.students.view_modal')
@endsection
@section('pagecss')
<style>
.custom-disabled-button {
  background-color: #ccc !important; 
  opacity: 0.3 !important;
  cursor: not-allowed !important; 
  pointer-events:none;
}
.disabled-button {
  background-color: #ccc !important; 
  opacity: 0.3 !important;
  cursor: not-allowed !important; 
}
</style>
@endsection
@section('scripts')


<script>
  $(".custom-disabled-button").on('mouseenter', function() { 
       showAlert('Sorry you cant use this feature as your data is being synched from wonde', "error", 1000);
  });
  $(function () {
  
      <?php 
    $statusmsg = '';    
    if(Session::has('status')){ ?>
      showAlert("{{ Session::get('status')}}", "success");
      <?php }  else if(Session::has('statusError')) { 
    $statusmsg = Session::get('statusError');
    ?>
      showAlert("{{ Session::get('statusError')}}", "error");
      <?php }else if(Session::has('statusInfo')) { 
    $statusmsg = Session::get('statusInfo');
    ?>
          showAlert("{{ Session::get('statusInfo')}}", "warning");
      <?php } ?>    
      <?php if(Session::has('classerror')){ ?>
         showAlert("{{ Session::get('classerror')}}", "error");
      <?php } ?>
  
      <?php if(Session::has('error')){ ?>
         showAlert("{{ Session::get('error')}}", "error");
      <?php } ?>
  
      
  
      <?php if(Session::has('skipstd')){ 
    $skipcount = Session::get('skipstd');
    if($skipcount>0){
    
    ?>
      var skipcount = "{{ $skipcount }}";
      Swal.fire({
        title: '{{ $statusmsg }}',
        text: skipcount+" students could not be imported. Do you want to downlaod it?",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, Downlaod it!'
      }).then((result) => {
          if (result.isConfirmed) {
               window.open("{{ url('teacher/student/download-skipstudents') }}", '_blank');
           
          }else{
              $.ajax({url: "{{ url('teacher/student/reset-downloads') }}", type: "GET", dataType: "html"}).done(function (a) {
              });                       
              
          }
      })
    
  <?php } 
    }
    ?>   
  
  });
  var table;
  
  document.addEventListener('DOMContentLoaded', function (e) {
      FormValidation.formValidation(
          document.getElementById('unitImportForm'),
          {
              fields: {
                  filename: {
                      validators: {
                          notEmpty: {
                              message: 'ERROR!'
                          }
                      }
                  },
              },
              plugins: {
                  trigger: new FormValidation.plugins.Trigger(),
                  bootstrap: new FormValidation.plugins.Bootstrap(),
                  submitButton: new FormValidation.plugins.SubmitButton(),
                  trigger: new FormValidation.plugins.Trigger(),
              },
          }
      ).on('core.form.valid', function () {
  
          $("#unitImportForm").submit();
  
      });
  
  });
  
  function importStudent() {
      $("#filename").val('');
      $("#filetype_error").text('');
      $("#studentImportModal").modal("show");
  }
  
  $(document).on('click', 'body #imp-button', function () {
      $fileVal = $("#filename").val();
      if ($fileVal == '') {
          $('.filetype_error').text("Please select a file");
          return false;
      }
  });
  
  $(document).on('change', '.up', function () {
      $(this).closest('.form-group').find('.filetype_error').text('');
      var type = null;
      var fileExtension = ['csv', 'xlsx', 'xls'];
      if ($.inArray($(this).val().split('.').pop().toLowerCase(), fileExtension) == -1) {
          type = $(this).val().split('.').pop().toLowerCase();
          $(this).closest('.form-group').find('.filetype_error').text("Your file type is " + type + ", Allowed file types : " + fileExtension.join(', '));
      } else {
          var names = [];
          var length = $(this).get(0).files.length;
          for (var i = 0; i < $(this).get(0).files.length; ++i) {
              names.push($(this).get(0).files[i].name);
          }
          // $("input[name=file]").val(names);
          if (length > 2) {
              var fileName = names.join(', ');
              $(this).closest('.form-group').find('.form-control').attr("value", length + " files selected");
          } else {
              $("#filename").val(names);
          }
      }
  });
  
  
  $(function () {
  
      // yid = $('.btn-country').first().attr('id')
  
      // setYear(yid);
      //Generate List
      table = $('#dataTables').DataTable({
          bSearchable: true,
          pagination: true,
          fixedHeader: true,
          responsive: true,
          searchDelay: 500,
          processing: !0,
          serverSide: !0,
          "aLengthMenu": [[50, 100, 500, -1], [50, 100, 500, "All"]],
          "pageLength": 50,
          dom: "<'row g-2 align-items-center justify-content-between'<'col text-start'l><'col-auto'f><'col-auto'B>>" +
        "<'row'<'col-sm-12'tr>>" +
        "<'row'<'col-sm-12 col-md-5 text-start'i><'col-sm-12 col-md-7'p>>",
        buttons: [
            {
              extend: 'excel',
              text: '<i class="bx bx-export fs-6"></i> Export',
              title: 'Students',
              className: 'btn btn-primary btn-sm w-100 quiz-export',
              exportOptions: {
                  columns: ':not(.no-export)'
              },
              action: newexportaction
            }
        ],
          ajax: {
              url: "{{ url('teacher/student/lists') }}",
              data: search
          },
          columns: [
              {data: "checkrows", name: "checkrows", orderable: false, searchable: !1},
              {data: "studname", name: 'studname'},
              {data: "fname", name: 'fname', sClass: "text-start"},
              {data: "username", name: 'username', sClass: "text-start"},
              {data: "email", name: 'email', sClass: "text-start"},
              {data: "year", name: 'year',  searchable: !1},
              {data: "class", name: 'class', searchable: !1},
              {data: "action", name: 'action', sClass: "tools", orderable: !1, searchable: !1}
  
          ],
          "columnDefs": [
              { "width": "0%", "targets": 0 },
                  {
                      "targets": [ 1 ],
                      "visible": false,
                      "searchable": false,
                      orderData: [ 1 ],
                  },
                  {
                      targets: [ 2 ],
                      orderData: [ 1 ],
                  },
                  {
                      targets: [ 3 ],
                  },
                  {
                      "targets": [4],
                  },
                  {
                      "targets": [5],
                  },
                  {
                      "targets": [6],
                  },
                 
          ],
          "order": [[ 1, "asc" ]]  
      });
  
      $(".searchs").keyup(function () {
          table.draw();
      });
      //setYear(1);
      // setClass(1);
  });
  
  
  function search(value) {
      value.search_name = $('input[name=name]').val();
      value.year = $('#year_fil').val();
      value.class = $('#class_fil').val();
  }
  
  function softDelete(b) {
      var student_ids = [];
      var errorStatus = true;
      if(b == null){
          $('input:checkbox.slectedrows').each(function () {
              if (this.checked) {
                  student_ids.push(this.value);
  
              }
          });
          if(student_ids.length > 0 ){
              b = student_ids;
              errorStatus = false;
          }
      } else {
          errorStatus = false;
      }
      if(errorStatus){
          showAlert("Please select students to delete", "error");
      } else {
          Swal.fire({
              title: "Are you sure?",
              text: "You are about to permanently delete student data. Please export and save student data before deleting.",
              icon: "warning",
              showCancelButton: true,
              confirmButtonText: "Yes, delete",
              confirmButtonColor: '#e85f5d',
          }).then(function (result) {
              if (result.value) {
                  Swal.fire({
                      title: "Check you have downloaded the student data as this cannot be retrieved once deleted. ",
                      text: "Contact us at info@kayscience.com if you have any questions.",
                      icon: "warning",
                      showCancelButton: true,
                      confirmButtonText: "Yes, delete",
                      confirmButtonColor: '#e85f5d'
                  }).then(function (result) {
                      if (result.value) {
                          $.ajax({url: "{{ url('teacher/student') }}/" + b, type: "DELETE", dataType: "html"})
                              .done(function (a) {
                                  var data = JSON.parse(a);
                                  if (data.flagError) {
                                      showAlert(data.message, "error");
                                  } else {
                                      showAlert(data.message, "success");
                                      setTimeout(function () {
                                          table.ajax.reload(null, false);
                                      }, 1000);
  
                                  }
                              }).fail(function () {
                              showAlert("Somthing went wrong!", "error");
                          });
                      }
                  })
  
              } else if (result.dismiss === "cancel") {
                  Swal.fire(
                      "Cancelled",
                      "",
                      "error"
                  )
              }
          });
      }
  }
  
  /* $(function () {
      var passwordForm = $("#ChangePasswordForm");
      var passwordValidator;
  
      passwordValidator = passwordForm.validate({
          rules: {
              password: "required",
              password_confirmation: "required"
          }, messages: {password: "Please enter password", password_confirmation: "Please confirm password"}
      });
  
      passwordForm.submit(function (b) {
          passwordForm.valid() && (b.preventDefault(), $.ajax({
              url: '{{ url('teacher/student/password') }}',
              type: "POST",
              data: $(this).serialize(),
              dataType: "html"
          }).done(function (a) {
              var data = JSON.parse(a);
              data.flagError ? ("undefined" != typeof data.errors && passwordValidator.showErrors(data.errors), "undefined" != typeof data.message && showAlert(data.message, "error")) : ($("#ChangePasswordModal").modal("hide"), showAlert(data.message, "success"), passwordForm[0].reset());
          }));
      });
  });*/
  
  
  $('#selectall').click(function (event) {
      if (this.checked) {
          $('.slectedrows').each(function () { //loop through each checkbox
              $(this).prop('checked', true); //check
          });
      } else {
          $('.slectedrows').each(function () { //loop through each checkbox
              $(this).prop('checked', false); //uncheck
          });
      }
  });
  
  function setYear(year_id) {
  
      $("#year_fil").val('');
      $('#class_fil').val('');
  
      if ($('#year_id-' + year_id).is(':checked')) {
          $('.checkyear').each(function () {
              $(this).prop('checked', false);
          });
          $("#year_fil").val(year_id);
          $('#year_id-' + year_id).prop('checked', true);
          $.ajax({
              url: "{{ url('common/getClassButtons') }}/" + year_id,
              type: "GET",
              dataType: "html"
          }).done(function (data) {
              $(".class-head").html(data);
              cur_id = $(".class-head button:first").attr('id');
              // $('#class_fil').val(cur_id);
              // $('.btn-cur').removeClass('active');
              // $('.btn-cur-'+cur_id).addClass('active');
              table.ajax.reload();
          });
      } else {
          $(".class-head").html('');
          table.ajax.reload();
      }
  
  }
  
  function setClass(class_id) {
      $('#class_fil').val(class_id);
      $('.btn-cur').removeClass('active');
      $('.btn-cur-' + class_id).addClass('active');
      table.ajax.reload();
  }
  
  $(document).on("keyup", 'input[type="search"]', function () {
      $("#searched_value").val($('input[type=search]').val());
  });
  function exportStudent() {
      var search_name = $("#searched_value").val();
      var year_id = $("#year_fil").val();
      var class_id = $("#class_fil").val();
      var student_ids = [];
  
      $('input:checkbox.slectedrows').each(function () {
          if (this.checked) {
              student_ids.push(this.value);
          }
      });
      $.ajax({
          xhrFields: {
                  responseType: 'blob',
          },
          url: "{{ url('teacher/student/export') }}",
          data:  {"year_id": year_id, "class_id":class_id, "student_ids": student_ids,"search_name":search_name},
          type: "POST",
          success: function(result, status, xhr) {
                      var disposition = xhr.getResponseHeader('content-disposition');
                      var matches = /"([^"]*)"/.exec(disposition);
                      var filename = (matches != null && matches[1] ? matches[1] : 'StudentsFile.xlsx');
  
                      var blob = new Blob([result], {
                          type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
                      });
                      var link = document.createElement('a');
                      link.href = window.URL.createObjectURL(blob);
                      link.download = filename;
  
                      document.body.appendChild(link);
  
                      link.click();
                      document.body.removeChild(link);
                  }
      });
  }
</script>
@endsection