<div class="modal fade" id="changeClassModal" tabindex="-1" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title"><b>Change Class</b></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">&times;</button>
      </div>
      <form class="form-horizontal"  method="POST"  enctype="multipart/form-data" id="changeClassForm" >
        {{ csrf_field() }}
        <div class="modal-body">
          <div class="form-group mb-2">
            <p>Select class to move the following student(s) to:</p>
            <p class="fw-semibold text-capitalize list_students"></p>
            {!! Form::hidden('students', '' , ['class' => 'form-control', 'id' => 'students'] ) !!}
          </div>
          <div class="form-group mb-2">
            <div class="mov_year_blck"></div>
          </div>
          <div class="form-group mb-2">
            <div class="mov_class_blck"></div>
          </div>
          <input type="hidden" id="move_class_id" name="move_class_id">
        </div>
        <div class="modal-footer">
          <button type="submit" class="btn btn-success" >Save</button>
        </div>
      </form>
    </div>
  </div>
</div>
@push('inner-scripts')
<script>
  document.addEventListener('DOMContentLoaded', function(e) {
      const classValidators = {
          validators: {
              notEmpty: {
                  message: 'Please select class'
              }
          }
      };
      const changeClassForm = document.getElementById('changeClassForm');
      const fv = FormValidation.formValidation(changeClassForm, {
              fields: {
                  move_year_id: {
                      validators: {
                          notEmpty: {
                              message: 'Please select a year'
                          }
                      }
                  },
              },
              plugins: {
                  trigger: new FormValidation.plugins.Trigger(),
                  bootstrap: new FormValidation.plugins.Bootstrap(),
                  submitButton: new FormValidation.plugins.SubmitButton(),
                  trigger: new FormValidation.plugins.Trigger(),
  
                  
              },
          }
      ).on('core.form.valid', function() {
          var forms = $("#changeClassForm");
          var allids = $("#students").val();
          var move_year = $("#move_year_id").val();
          var move_class = $("#class_ids").val();
          $.ajax({
              url: "{{ url('teacher/student/move-class') }}/"+allids+"/"+move_class+"/"+move_year ,
              type: "POST",
              data:{"students":allids,"class":move_class,"year":move_year},
              dataType: "html",
            //  contentType: false,
             // processData: false
          })
              .done(function (a) {
                  var data = JSON.parse(a);
                  if (data.flagError == true) {
                      formValidate.showErrors(data.errors);
                      showAlert(data.message, "error");
                  }
                  else {
                  $("#changeClassForm")[0].reset();
                  $("#changeClassModal").modal("hide");
                  showAlert(data.message, "success");
                  setTimeout(function () {
                      table.ajax.reload(null, false);
                  }, 2000);
              }
              });
          
      });
    /***  $(document).on('change', '#move_year_id', function () {
          $.ajax({
          url: "{{ url('common/getClasses') }}/"+$(this).val(),
          type: "GET",
          dataType: "html"
          }).done(function (data) {
                  $(".mov_class_blck").next().remove();
                  $(".mov_class_blck").html(data);
                  fv.addField('class_id', classValidators); 
          })
      });
      $(document).on('change', '#class_id', function () {
          $("#move_class_id").val($(this).val());
      });
  });*/
  $(document).on('change', '#move_year_id', function () {
      $.ajax({
      url: "{{ url('common/getClassesMultiple') }}/"+$(this).val(),
      type: "GET",
      dataType: "html"
      }).done(function (data) {
              var flag = 0;     
              $(".mov_class_blck").next().remove();
              $(".mov_class_blck").html(data);
              openTriggerBoxHere(); 
             var title = $(".student-mng").html();
              selectedValue = $('.select2-selection__choice').data('select2-id'); 
              if(selectedValue !== undefined){ 
                  $('.fv-plugins-message-container').remove();
              }
              else{
                    $('.mov_class_blck').append('<div class="fv-plugins-message-container"></div>')
              }          
              if($("#move_class_id").val() == 0){
                  $("body").find("#class_ids").val('').select2();
              } 
      })
  });
  $('#class_ids').select2().on('change', function(){ 
      selectedValue = $('.select2-selection__choice').data('select2-id'); 
      if(selectedValue !== undefined){ 
          $('.fv-plugins-message-container').remove();
      }
      else{
          $('.mov_class_blck').append('<div class="fv-plugins-message-container"></div>')
      }
  });
  });
  
  
  var classSelected = 0;
  $(document).ready(function() {
  openTriggerBoxHere();
  });
  
  function openTriggerBoxHere(){
  classSelected = 0;
  $("select").on("select2:close", function (e) {  
      ////
      console.log(0);
      classSelected = 0;
      $('.select2-selection .select2-selection__rendered').each(function(i, items_list){
          $(items_list).find('li').each(function(j, li){
              console.log(1);
              classSelected = classSelected + 1;
          })
      });
      ////
      if(classSelected > 1){
          $('#class_blck .fv-plugins-message-container').slideUp('fast', function() {});
      }else{
          $('#class_blck .fv-plugins-message-container').slideDown('fast', function() {});
      }
  });
  } 
  
  
  function moveToClass(studentId,yearId) {
      if(studentId && yearId){
          year = yearId;
      } else {
          year = $('#year_fil').val();
      }
      if(year==''){
          showAlert("Please select the year first", "error");
      }else{
  
          var checkedIds = Array();
          var allids = '';
          var error_status = false;
          if(studentId == null){
              var length = $('input:checkbox.slectedrows:checked').length;
              if (length > 0)
              {
                  $('input:checkbox.slectedrows:checked').each(function (index)
                  {
                      if (allids == '')
                      {
                          allids = $(this).val();
                      } else
                      {
                          allids = allids + ',' + $(this).val();
                      }
                      checkedIds.push($(this).val());
                  });
              } else
              {
                  error_status = true;
              }
          } else {
              if (allids == '')
              {
                  allids = studentId;
              } else
              {
                  allids = allids + ',' + studentId;
              }
              checkedIds.push(studentId);
          }
          if(error_status){
              showAlert("Please select the students first", "error");
          } else {
              allids = encodeURIComponent(allids);
              $("#students").val(allids);
              $.ajax({
                  //url: "{{ url('teacher/student/show-class') }}/"+allids,
                  url: "{{ url('teacher/student/show-year') }}/"+year+"/"+allids,
                  type: "POST",
                  dataType: "html",
                  contentType: false,
                  processData: false
              }).done(function (a) {
                  var data = JSON.parse(a);
                  if(data.flagError){
                      showAlert(data.message, "error");
                  } else {
                      $(".mov_year_blck").html(data.form);
                      $(".list_students").html(data.student_names);
                      $(".mov_class_blck").html("");
                      $("#changeClassModal").modal("show");
                  }
              }).fail(function () {
                      showAlert("Please try again...", "error");
              });
          }
      }
  }
</script>
@endpush