<div class="modal fade" id="resetPasswordModal" tabindex="-1" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Reset Password</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">&times;</button>
      </div>
      <form class="form-horizontal"  method="POST"  enctype="multipart/form-data" id="resetPasswordForm" >
        {{ csrf_field() }}
        <div class="modal-body">
          <h2 class="fs-5">Do you want to reset the password for:</h2>
          <div class="form-group">
            <div class="reset_list_students"></div>
            {!! Form::hidden('reset_students', '' , ['class' => 'form-control', 'id' => 'reset_students'] ) !!}
          </div>
        </div>
        <div class="modal-footer justify-content-between">
          <div class="form-group">
            <label for="inputEmail3" class="control-label"></label>
          </div>
          <div class="form-group d-flex justify-content-end">
            <button type="button" class="btn btn-warning cancel me-1">Cancel</button>
            <button type="submit" class="btn btn-success" >Confirm</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
@push('inner-scripts')
<script>
  document.addEventListener('DOMContentLoaded', function(e) {
              FormValidation.formValidation(
                  document.getElementById('resetPasswordForm'),
                  {
                      fields: {
                          
                      },
                      plugins: {
                          trigger: new FormValidation.plugins.Trigger(),
                          bootstrap: new FormValidation.plugins.Bootstrap(),
                          submitButton: new FormValidation.plugins.SubmitButton(),
                          trigger: new FormValidation.plugins.Trigger(),
         
                          
                      },
                  }
              ).on('core.form.valid', function() {
                  var forms = $("#resetPasswordForm");
                  var allids = $("#reset_students").val();
                  $.ajax({
                      url: "{{ url('teacher/student/reset-password') }}/"+allids ,
                      type: "POST",
                      dataType: "html",
                      contentType: false,
                      processData: false
                  })
                      .done(function (a) {
                          var data = JSON.parse(a);
                          if (data.flagError == true) {
                              formValidate.showErrors(data.errors);
                              showAlert(data.message, "error");
                          }
                          else {
                          $("#resetPasswordForm")[0].reset();
                          $("#resetPasswordModal").modal("hide");
                          showAlert(data.message, "success");
                          setTimeout(function () {
                              table.ajax.reload(null, false);
                          }, 2000);
                      }
                      });
                  
              });
  
      });
      function changePassword(studentId) {
          var checkedIds = Array();
          var allids = '';
          var error_status = false;
          if(studentId == null){
              var length = $('input:checkbox.slectedrows:checked').length;
              if (length > 0)
              {
                  $('input:checkbox.slectedrows:checked').each(function (index)
                  {
                      if (allids == '')
                      {
                          allids = $(this).val();
                      } else
                      {
                          allids = allids + ',' + $(this).val();
                      }
                      checkedIds.push($(this).val());
                  });
              } else
              {
                  error_status = true;
              }
          } else {
              if (allids == '')
              {
                  allids = studentId;
              } else
              {
                  allids = allids + ',' + studentId;
              }
              checkedIds.push(studentId);
          }
          if(error_status){
              showAlert("Please select the students first", "error");
          } else {
              allids = encodeURIComponent(allids);
              $("#reset_students").val(allids);
              $.ajax({
                  url: "{{ url('teacher/student/reset-password-show') }}/"+allids, 
                  dataType: "html",
                  type: "POST",
                  contentType: false,
                  processData: false
              })
              .done(function (a) {
                  var data = JSON.parse(a);
                  if(data.flagError){
                      showAlert(data.message, "error");
                  } else {
                      $("#mov_class_blck").html(data.form);
                      $(".reset_list_students").html(data.student_names);
                      $("#resetPasswordModal").modal("show");
                  }
              }).fail(function () {
                      showAlert("Please try again...", "error");
              });
          }
      }     
      $(document).on('click', '.cancel', function () {
          $("#resetPasswordModal").modal("hide");
      });
</script>
@endpush