<div class="modal fade" id="studentImportModal" tabindex="-1" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title"><b>Import Students</b></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">&times;</button>
      </div>
      <form class="form-horizontal"  method="POST" name="topicImportForm" id="topicImportForm"  enctype="multipart/form-data" action="{{ url('teacher/student/import') }}">
        {{ csrf_field() }}
        <div class="modal-body">
          <div class="form-group mb-2">
            <div class="custom-file mb-2">
              <label for="import_file" class="form-label">File Browser</label>
              <input type="file" name="import_file" id="import_file" accept=".csv, .xls, .xlsx" class="form-control custom-file-input">
            </div>
            <span class="form-text text-muted">Allowed file types:  csv, xls, xlsx.</span>
            @if ($errors->has('importFile'))
            <span class="help-block">
            <strong>{{ $errors->first('importFile') }}</strong>
            </span>
            @endif
            <span class="help-block">
              <p class="filetype_error text-danger"></p>
            </span>
          </div>
          <div class="form-group">
            <a href="{{ url('/') }}/sample/student_sample_template.xlsx" class="btn btn-success btn-sm">Download Sample</a>
          </div>
        </div>
        <div class="modal-footer">
          <label for="inputEmail3" class="control-label"></label>
          <button type="submit" id="imp-button" class="btn btn-primary">Import</button>
        </div>
      </form>
    </div>
  </div>
</div>
@push('inner-scripts')
<script>
  function importTopic() {
      $("#filename").val('');
      $("#filetype_error").text('');
      $("#studentImportModal").modal("show");
      $(":submit").attr("disabled", true);
    }
  
    $(document).on('click','body #imp-button',function(){
      $fileVal = $("#import_file").val();
      if($fileVal == ''){
          $('.filetype_error').text("Please select a file");
          return false;
      }
    });
  
      $(document).on('change','#import_file', function(){
          $(this).closest('.form-group').find('.filetype_error').text('');
          var type = null;
          var fileExtension = ['csv', 'xlsx', 'xls'];
          if ($.inArray($(this).val().split('.').pop().toLowerCase(), fileExtension) == -1) {
              type = $(this).val().split('.').pop().toLowerCase();
              $(this).closest('.form-group').find('.filetype_error').text("Your file type is "+type+", Allowed file types : "+fileExtension.join(', '));
              $(":submit").attr("disabled", true);
          } else {
              var names = [];
              var length = $(this).get(0).files.length;
              for (var i = 0; i < $(this).get(0).files.length; ++i) {
                  names.push($(this).get(0).files[i].name);
              }
              // $("input[name=file]").val(names);
              if(length>2){
              var fileName = names.join(', ');
              $(this).closest('.form-group').find('.form-control').attr("value",length+" files selected");
              }
              else{
                  $("#filename").val(names);
              }
              $(":submit").removeAttr("disabled");
          }
    });
     
</script>
@endpush