<!--suppress JSUnusedLocalSymbols -->
<div class="modal fade" id="studentImportModal" role="dialog"  style="display:none;">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Import Students</h4>
                 <button type="button" class="close btn btn-icon btn-danger btn-sm" data-dismiss="modal">&times;</button> 
            </div>
            <form class="form-horizontal"  method="POST" name="topicImportForm" id="topicImportForm"  enctype="multipart/form-data" action="{{ url('teacher/student/import') }}">
                {{ csrf_field() }}
                <div class="modal-body">
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>File Browser</label>
                            <div></div>
                            <div class="custom-file">
                                    <input type="file" name="import_file" id="import_file" accept=".csv, .xls, .xlsx" class="custom-file-input">
                                    <label class="custom-file-label" for="customFile">Choose file</label>
                                </div>
                            <!-- <div class="custom-file1 input-group">
                                <input type="text" id="filename" name="filename" class="form-control"  readonly >
                                <div class="input-group-btn">
                                    <span class="fileUpload btn btn-warning">
                                        <span class="upl" id="upload">Select File</span>
                                        <input type="file" class="upload up" id="importFile" name="importFile" onchange="readURL(this);"  accept=".csv, .xls, .xlsx"/>
                                    </span>
                                </div>
                            </div> -->
                            <span class="form-text text-muted">Allowed file types:  csv, xls, xlsx.</span>
                            @if ($errors->has('importFile'))
                                <span class="help-block">
                                    <strong>{{ $errors->first('importFile') }}</strong>
                                </span>
                            @endif
                            <span class="help-block">
                                <p class="filetype_error text-danger"></p>
                            </span>
                        </div>
                    </div>
                    <div class="form-group col-sm-12 col-xs-12">
                        <a href="{{ url('/') }}/sample/student_sample_template.xlsx" class="btn btn-info btn-sm">Download Sample</a>
                    </div> 
                </div>
                <div class="modal-footer" style="border:0">
                    <div class="col-sm-12">
                        <div class="form-group row">
                            <label for="inputEmail3" class="col-sm-10 control-label">&nbsp; </label>
                            <div class="col-sm-2">
                                <button type="submit" id="imp-button" class="btn btn btn-info font-weight-bold" >Import</button>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>


@push('inner-scripts')
    
<script>

        
    function importTopic() {
        $("#filename").val('');
        $("#filetype_error").text('');
        $("#studentImportModal").modal("show");
        $(":submit").attr("disabled", true);
      }

      $(document).on('click','body #imp-button',function(){
        $fileVal = $("#import_file").val();
        if($fileVal == ''){
            $('.filetype_error').text("Please select a file");
            return false;
        }
      });

        $(document).on('change','#import_file', function(){
            $(this).closest('.form-group').find('.filetype_error').text('');
            var type = null;
            var fileExtension = ['csv', 'xlsx', 'xls'];
            if ($.inArray($(this).val().split('.').pop().toLowerCase(), fileExtension) == -1) {
                type = $(this).val().split('.').pop().toLowerCase();
                $(this).closest('.form-group').find('.filetype_error').text("Your file type is "+type+", Allowed file types : "+fileExtension.join(', '));
                $(":submit").attr("disabled", true);
            } else {
                var names = [];
                var length = $(this).get(0).files.length;
                for (var i = 0; i < $(this).get(0).files.length; ++i) {
                    names.push($(this).get(0).files[i].name);
                }
                // $("input[name=file]").val(names);
                if(length>2){
                var fileName = names.join(', ');
                $(this).closest('.form-group').find('.form-control').attr("value",length+" files selected");
                }
                else{
                    $("#filename").val(names);
                }
                $(":submit").removeAttr("disabled");
            }
      });
       
</script>
@endpush

