<div class="modal fade" id="studentModal" tabindex="-1" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title student-mng"><b>Add New Student</b></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">&times;</button>
      </div>
      <form class="form-horizontal"  method="POST"  enctype="multipart/form-data" id="studentForm" >
        {{ csrf_field() }}
        {!! Form::hidden('student_id', '' , [ 'id' => 'student_id'] ) !!}
        <div class="modal-body">
          <div class="row">
            <div class="form-group col-md-6">
              <label class="col-form-label">First Name <span class="text-danger">*</span></label>
              {!! Form::text('fname', '' , ['class' => 'form-control', 'id' => 'fname', 'placeholder' => "First Name"] ) !!}
              
            </div>
            <div class="form-group col-md-6">
              <label class="col-form-label">Second Name <span class="text-danger">*</span></label>
                {!! Form::text('lname', '' , ['class' => 'form-control', 'id' => 'lname', 'placeholder' => "Second Name"] ) !!}
            </div>
            <div class="form-group col-md-6">
              <label class="col-form-label">Year <span class="text-danger">*</span></label>
              <div id="year_blck">
                {!! Form::select('year_id', $years , '', ['class' => 'form-select ', 'id' => 'year_id', 'style' => 'width:100%','placeholder'=>'Select Year']) !!}
              </div>
            </div>
            <div class="form-group col-md-6">
              <label class="col-form-label class-heading">Class <span class="text-danger">*</span></label>
              <input type="hidden" id="hid_class_id" value=0>
              <div id="class_blck">
                {!! Form::select('class_id', $class , '', ['class' => 'form-select new-drop-section select2', 'style' => 'width:100%','id' => 'class_id','multiple'=>'multiple','name'=>'class_id[]']) !!}
              </div>
            </div>
            <div class="form-group col-md-6">
              <label class="col-form-label">Email </label>
              <div>
                {!! Form::text('email', '' , ['class' => 'form-control', 'id' => 'email', 'placeholder' => "Email"] ) !!}   
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <label for="inputEmail3" class="control-label"></label>
          <button type="submit" class="btn btn-success">Save</button>
        </div>
      </form>
    </div>
  </div>
</div>
@push('inner-scripts')
<script>
  var classSelected = 0;
  $(document).ready(function() {
      openTriggerBoxHere();
  });
  
  function openTriggerBoxHere(){
      classSelected = 0;
      $("select").on("select2:close", function (e) {  
          ////
          console.log(0);
          classSelected = 0;
          $('.select2-selection .select2-selection__rendered').each(function(i, items_list){
              $(items_list).find('li').each(function(j, li){
                  classSelected = classSelected + 1;
              })
          });
          ////
          if(classSelected > 1){
              $('#class_blck .fv-plugins-message-container').slideUp('fast', function() {});
          }else{
              $('#class_blck .fv-plugins-message-container').slideDown('fast', function() {});
          }
          ////
      });
  }
  
  document.addEventListener('DOMContentLoaded', function(e) {
      const curriculumValidators = {
          validators: {
              notEmpty: {
                  message: 'Please select curriculum'
              }
          }
      };
      const classValidators = {
          validators: {
              notEmpty: {
              //    message: 'Please select class'
              }
          }
      };
      const subjectValidators = {
          validators: {
              notEmpty: {
                  message: 'Please select subject'
              }
          }
      };
      const studentForm = document.getElementById('studentForm');
          var forms = $("#studentForm");
          const fv = FormValidation.formValidation(studentForm, {
                      fields: {
                          fname: {
                              validators: {
                                  notEmpty: {
                                      message: 'Please enter first name'
                                  },
                                  callback: {
                                      callback: function (input) {
                                          const value = input.value;
                                          if (/^[A-Za-z][A-Za-z\'\-]+([\ A-Za-z][A-Za-z\'\-]+)*/.test(value) == false) {
                                              return {
                                                  valid: false,
                                                  message: 'Please enter valid first name',
                                              };
                                          }
                                          return {valid: true};
                                      },
                                  }
                              }
                          },
                          lname: {
                              validators: {
                                  notEmpty: {
                                      message: 'Please enter second name'
                                  },
                                  callback: {
                                      callback: function (input) {
                                          const value = input.value;
                                          if (/^[A-Za-z][A-Za-z\'\-]+([\ A-Za-z][A-Za-z\'\-]+)*/.test(value) == false){
                                              return {
                                                  valid: false,
                                                  message: 'Please enter valid second name',
                                              };
                                          }
                                          return {valid: true};
                                      },
                                  },
                              }
                          },
                            email: {
                               validators: {
                                   
                                   callback: {
                                       message: 'The value is not a valid email',
                                       callback: function(input) {
                                           const value = input.value;
                                           if (value === '') {
                                               return true;
                                           }
  
                                           // I want the value has to pass both emailAddress and regexp validators
                                           return FormValidation.validators.emailAddress().validate({
                                                   value: value,
                                               }).valid &&
                                               FormValidation.validators.regexp().validate({
                                                   value: value,
                                                  options: {
                                                       regexp: '^[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*@[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*$',
                                                   },
                                               }).valid;
                                       },
                                   }
                               }
                           }, 
                         combined_all: {
                              validators: {
                                  notEmpty: {
                                      message: 'Please select any science'
                                  }
                              }
                          }, 
                          year_id: {
                              validators: {
                                  notEmpty: {
                                      message: 'Please select year'
                                  }
                              }
                          },
                          class_id: classValidators
                        },
                      plugins: {
                          trigger: new FormValidation.plugins.Trigger(),
                          bootstrap: new FormValidation.plugins.Bootstrap(),
                          submitButton: new FormValidation.plugins.SubmitButton(),
                          trigger: new FormValidation.plugins.Trigger(),
         
                          
                      },
                  }
              ).on('core.form.valid', function() {
                      //var flag = 0;
  //                    if(classSelected > 0){
                          id = $("#student_id").val();
                          studentId = "" == id ? "" : "/" + id;
                          
                          studentMethod = "" == id ? "POST" : "PUT";
                          
                          $.ajax({
                              url: "{{ url('teacher/student/check') }}",
                              type: "POST",
                              data: forms.serialize(),
                              dataType: "html"
                          })
                              .done(function (a) {
                                  var data = JSON.parse(a); 
                                  if(id === ""){
                                      if(data.exists){
                                          Swal.fire({
                                              title: "Are you sure?",
                                              text: "Same user with first name and last name already exists.Do you want to save again?",
                                              icon: "warning",
                                              showCancelButton: true,
                                              confirmButtonText: "Yes",
                                              confirmButtonColor: '#e85f5d',
                                          }).then(function (result) {
                                              if (result.value) { 
                                                  id = $("#student_id").val();
                                                  studentId = "" == id ? "" : "/" + id;
                                                  
                                                  studentMethod = "" == id ? "POST" : "PUT";
                                                  // var forms = $("#studentForm"); 
                                                  $.ajax({
                                                      url: "{{ url('teacher/student') }}" + studentId,
                                                      type: studentMethod,
                                                      data: data.data,
                                                      dataType: "html"
                                                  }).done(function (a) {
                                                      var data = JSON.parse(a); 
                                                      if (data.flagError == true) {
                                                          showAlert(data.message, "error");
                                                      }
                                                      else {
                                                          $("#studentForm")[0].reset();
                                                          $("#studentModal").modal("hide");
                                                          showAlert(data.message, "success");
                                                          setTimeout(function () {
                                                              table.ajax.reload(null, false);
                                                          }, 2000);
                                                      }
                                                  });
                                              } else if (result.dismiss === "cancel") {
                                                  Swal.fire(
                                                      "Cancelled",
                                                      "",
                                                      "error"
                                                  )
                                              }
                                          });
                                      }
                                      else{
                                          if (data.flagError == true) {
                                              showAlert(data.message, "error");
                                          }
                                          else {
                                              $("#studentForm")[0].reset();
                                              $("#studentModal").modal("hide");
                                              showAlert(data.message, "success");
                                              setTimeout(function () {
                                                  table.ajax.reload(null, false);
                                              }, 2000);
                                          }
                                      }
                                  }
                                  else{ 
                                      id = $("#student_id").val();
                                      studentId = "" == id ? "" : "/" + id;
                                      
                                      studentMethod = "" == id ? "POST" : "PUT";
                                      // var forms = $("#studentForm"); 
                                      $.ajax({
                                          url: "{{ url('teacher/student') }}" + studentId,
                                          type: studentMethod,
                                          data: forms.serialize(),
                                          dataType: "html"
                                      }).done(function (a) {
                                          var data = JSON.parse(a); 
                                          if (data.flagError == true) {
                                          showAlert(data.message, "error");
                                      }
                                      else {
                                          $("#studentForm")[0].reset();
                                          $("#studentModal").modal("hide");
                                          showAlert(data.message, "success");
                                          setTimeout(function () {
                                              table.ajax.reload(null, false);
                                          }, 2000);
                                      }
                                      });
                                  }
                                
                          });
                     // }
              });
           
      });
      $(document).on('change', '#year_id', function () {
          $.ajax({
          url: "{{ url('common/getClassesForStudents') }}/"+$(this).val(),
          type: "GET",
          dataType: "html"
          }).done(function (data) {
                  var flag = 0;     
                  $("#class_blck").next().remove();
                  $("#class_blck").html(data);
                  openTriggerBoxHere(); 
                  var title = $(".student-mng").html();
                  selectedValue = $('.select2-selection__choice').data('select2-id'); 
                  if(selectedValue !== undefined){ 
                      $('.fv-plugins-message-container').remove();
                  }
                  else{
                        $('#class_blck').append('<div class="fv-plugins-message-container"><div data-field="class_id[]" data-validator="notEmpty" class="fv-help-block">Please select class</div></div>')
                  }          
                  if($("#hid_class_id").val() == 0){
                      $("body").find("#class_id").val('').select2();
                  } else{
                      value = $("#hid_class_id").val(); 
                      var array = value.split(','); 
                      $("#class_id").select2().val(array).trigger('change.select2');
                  
                  }
          })
      });
      function addStudent(studentId) {
          if (studentId === null) {
              // $("#email").prop('disabled',false);
              $("#studentForm")[0].reset();
              $("#student_id").val('');
              $("#year_id").val('').trigger('change');
              $("#class_id").val('').trigger('change');
              $(".student-mng").html("Add New Student");
              $("#studentModal").modal("show");
          } else {
              $(".student-mng").html("Edit Student");
              $.ajax({url: "{{ url('teacher/student') }}/" + studentId + "/edit", type: "GET", dataType: "html"})
                  .done(function (a) {
                      var data = JSON.parse(a);
                      // $("#email").prop('disabled',true);
                      $("#year_id").val(data.year_id).trigger('change');    
                      $("#student_id").val(data.student_id);
                      $("#fname").val(data.fname);
                      $("#lname").val(data.lname);
                      $("#teacher_id").val(data.teacher_id);
                      $("#hid_class_id").val(data.class_id);  
                      $("#class_id").select2().val(data.class_id).trigger('change');
                      $("#class_id").select2('close');
                      openTriggerBoxHere(); 
                      // $("#class_id").val(data.class_id);  
                      $("#combined_all").val(data.combined_all);  
                      $('.class-heading').html("Class or Multiple Classes");
                      $("#email").val(data.email_id);
                      $("#studentModal").modal("show");
                  }).fail(function () {
                      showAlert("Please try again...", "error");
              });
          }
      }
      function editStudent(studentId) {
            var student_ids = [];
              var errorStatus = true;
              if(studentId == null){
                  $('input:checkbox.slectedrows').each(function () {
                      if (this.checked) { console.log(this.value);
                          student_ids.push(this.value);
  
                      }
                  });
                  if(student_ids.length > 0 ){
                      studentId = student_ids;
                      errorStatus = false;
                  }
              } else {
                  errorStatus = false;
              }
              if(errorStatus){
                  showAlert("Please select students to edit", "error");
              }  
              else {
              $.ajax({url: "{{ url('teacher/student') }}/" + studentId + "/edit", type: "GET", dataType: "html"})
                  .done(function (a) {
                      var data = JSON.parse(a);
                      // $("#email").prop('disabled',true);
                      $("#student_id").val(data.student_id);
                      $("#fname").val(data.fname);
                      $("#lname").val(data.lname);
                      $("#email").val(data.email_id);
                      $("#teacher_id").val(data.teacher_id);
                      $("#year_id").val(data.year_id);    
                      $("#hid_class_id").val(data.class_id);  
                      $("#class_id").select2().val(data.class_id).trigger('change');
                      $("#class_id").select2('close');
                      openTriggerBoxHere(); 
                      // $("#class_id").val(data.class_id);  
                      $("#combined_all").val(data.combined_all);  
                      $(".student-mng").html("Edit Student");
                      $('.class-heading').html("Class or Multiple Classes");
                      $("#studentModal").modal("show");
                   
                  }).fail(function () {
                      showAlert("Please try again...", "error");
              });
          }
      }
  
  
      $(document).on('change', '#country_id', function () {
        $.ajax({
             url: "{{ url('common/getCurriculum') }}/"+$(this).val(),
             type: "GET",
             dataType: "html"
         }).done(function (data) {
          //  $('#year_id').prop('selectedIndex',0);
           fv.addField('curriculum_id', curriculumValidators);
           $("#curriculum_blck").html(data);
           $("#curriculum_blck").next().remove();
         })
      });
   $(document).on('change', '#class_id', function () {
        $.ajax({
             url: "{{ url('common/getClassCurriculum') }}/"+$(this).val(),
             type: "GET",
             dataType: "html"
         }).done(function (result) {
             var data = JSON.parse(result);
             selectedValue =  $('.select2-selection__choice').data('select2-id'); 
             if(data.flagError ==  false) {  
                  //   $('#class_id').val(data.classList);
                  //   $('#class_id').trigger('change.select2');
                     showMessage('Please select class with same curriculum.','error');
             }          
         })
      });
               
      function showMessage(content, type){ 
          toastr.options = {
              "closeButton": true,
              "debug": true,
              "newestOnTop": true,
              "progressBar": true,
              "positionClass": "toast-bottom-right",
              "preventDuplicates": true,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
              };
              toastr.error(content, "Error") ;            
      }
  
      $('#class_id').select2().on('change', function(){ 
          selectedValue = $('.select2-selection__choice').data('select2-id'); 
          if(selectedValue !== undefined){ 
              $('.fv-plugins-message-container').remove();
          }
          else{
              $('#class_blck').append('<div class="fv-plugins-message-container"><div data-field="class_id[]" data-validator="notEmpty" class="fv-help-block">Please select class</div></div>')
          }
      });
</script>
@endpush